Codeforces Contest 915 problem D Almost Acyclic Graph —— 枚举+拓扑

You are given a directed graph consisting of n vertices and m edges (each edge is directed, so it can be traversed in only one direction). You are allowed to remove at most one edge from it.

Can you make this graph acyclic by removing at most one edge from it? A directed graph is called acyclic iff it doesn’t contain any cycle (a non-empty path that starts and ends in the same vertex).

Input
The first line contains two integers n and m (2 ≤ n ≤ 500, 1 ≤ m ≤ min(n(n - 1), 100000)) — the number of vertices and the number of edges, respectively.

Then m lines follow. Each line contains two integers u and v denoting a directed edge going from vertex u to vertex v (1 ≤ u, v ≤ n, u ≠ v). Each ordered pair (u, v) is listed at most once (there is at most one directed edge from u to v).

Output
If it is possible to make this graph acyclic by removing at most one edge, print YES. Otherwise, print NO.

Examples
inputCopy
3 4
1 2
2 3
3 2
3 1
outputCopy
YES
inputCopy
5 6
1 2
2 3
3 2
3 1
2 1
4 5
outputCopy
NO
Note
In the first example you can remove edge , and the graph becomes acyclic.

In the second example you have to remove at least two edges (for example, and ) in order to make the graph acyclic.

题意:

给你n个点,m条有向边,问你有没有可能删掉一条使得它不存在环

题解:

由于n是500,,暴力枚举每个点的入度-1的情况再拓扑即可。。。

#include<bits/stdc++.h>
using namespace std;
int n,m;
struct node
{
    int to,next;
}e[100005];
int cnt,head[505];
void add(int x,int y)
{
    e[cnt].to=y;
    e[cnt].next=head[x];
    head[x]=cnt++;
}
int in[505],indeg[505];
int topo()
{
    queue<int>q;
    int k=0;
    for(int i=1;i<=n;i++)
        if(indeg[i]==0)
            q.push(i),k++;
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        //order[u]=k++;
        for(int i=head[u]; i!=-1; i=e[i].next)
        {
            int v=e[i].to;
            indeg[v]--;
            if(indeg[v]==0)
                q.push(v),k++;
        }
    }
    return k==n?1:0;
}
int main()
{
    memset(head,-1,sizeof(head));
    scanf("%d%d",&n,&m);
    int x,y;
    for(int i=1;i<=m;i++)
        scanf("%d%d",&x,&y),add(x,y),in[y]++;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
            indeg[j]=in[j];
        if(indeg[i])
        {
            indeg[i]--;
            if(topo())
                return 0*printf("YES\n");
        }
    }
    return 0*printf("NO\n");
}

猜你喜欢

转载自blog.csdn.net/tianyizhicheng/article/details/88956707